package com.zeekling.abstractFactory.impl;

import com.zeekling.abstractFactory.AbstractFactory;
import com.zeekling.abstractFactory.Display;
import com.zeekling.abstractFactory.Board;

import java.lang.reflect.InvocationTargetException;

/**
 * Created by lzh on 16-6-10.
 */
public class FactoryImpl implements AbstractFactory {
  private Display button = null;
  private Board panel = null;

  public FactoryImpl() {
    try {
      button = DisplayImpl.class.getDeclaredConstructor().newInstance();
      panel = BoardImpl.class.getDeclaredConstructor().newInstance();
    } catch (InstantiationException | IllegalAccessException | NoSuchMethodException | InvocationTargetException e) {
      e.printStackTrace();
    }
  }

  @Override
  public String america() {
    return panel.americaBoard() + ":" + button.americaDisplay();
  }

  @Override
  public String chinese() {
    return panel.chineseBoard() + ":" + button.chineseDisplay();
  }
}
