# 适配器模式
## 适配器模式有两种实现方式：
类适配器模式和对象适配器模式
* 类适配器模式：就是让适配器角色继承源角色、实现目标接口。
* 对象适配器模式：就是在目标接口的实现类中new一个源角色的对象，通过这个对象达到适配的效果。
在tomcat中有好多地方都用到了适配器模式，在平时的开发中也遇到了适配器模式。
## 类适配器模式
![类适配器模式](http://www.zeekling.cn/gogs/zeek/designPattern/raw/master/pics/classAdapter.png) <br>
在上图中可以看出，Adaptee类并没有sampleOperation2()方法，而客户端则期待这个方法。为使客户端能够
使用Adaptee类，提供一个中间环节，即类Adapter，把Adaptee的API与Target类的API衔接起来。Adapter与
Adaptee是继承关系，这决定了这个适配器模式是类的。
#### 目标(Target)角色
这就是所期待得到的接口。注意：由于这里讨论的是类适配器模式，因此目标不可以是类。
#### 源(Adapee)角色
现在需要适配的接口。
#### 适配器(Adaper)角色
适配器类是本模式的核心。适配器把源接口转换成目标接口。显然，这一角色不可以是接口，而必须是具体类。
## 对象适配器
与类的适配器模式一样，对象的适配器模式把被适配的类的API转换成为目标类的API，与类的适配器模式不同
的是，对象的适配器模式不是使用继承关系连接到Adaptee类，而是使用委派关系连接到Adaptee类。<br>

![对象适配器模式](http://www.zeekling.cn/gogs/zeek/designPattern/raw/master/pics/objectAdapter.png) <br>

从上图可以看出，Adaptee类并没有sampleOperation2()方法，而客户端则期待这个方法。为使客户端能够使用
Adaptee类，需要提供一个包装Wrapper类Adapter。这个包装类包装了一个Adaptee的实例，从而此包装类能够
把Adaptee的API与Target类的API衔接起来。Adapter与Adaptee是委派关系，这决定了适配器模式是对象的。
## 优点
*	将目标类和适配者类解耦，通过引入一个适配器类来重用现有的适配者类，而无须修改原有代码。
*	增加了类的透明性和复用性，将具体的实现封装在适配者类中，对于客户端类来说是透明的，而且提高了适配者的复用性。
*	灵活性和扩展性都非常好，通过使用配置文件，可以很方便地更换适配器，也可以在不修改原有代码的基础上增加新的适
配器类，完全符合“开闭原则”。<br>

#### 类适配器模式还具有如下优点
*	由于适配器类是适配者类的子类，因此可以在适配器类中置换一些适配者的方法，使得适配器的灵活性更强。

#### 对象适配器模式还具有如下优点
*	一个对象适配器可以把多个不同的适配者适配到同一个目标，也就是说，同一个适配器可以把适配者类和它的子类都适配到目标接口。

## 缺点

#### 类适配器模式的缺点
*	一次最多只能适配一个适配者类，而且目标抽象类只能为抽象类，不能为具体类，其使用有一定的局限性，
不能将一个适配者类和它的子类都适配到目标接口。

#### 对象适配器的缺点
*	与类适配器模式相比，要想置换适配者类的方法就不容易。如果一定要置换掉适配者类的一个或多个方法，
就只好先做一个适配者类的子类，将适配者类的方法置换掉，然后再把适配者类的子类当做真正的适配者进
行适配，实现过程较为复杂。

