# 建造者模式
## 简介
建造者模式（com.zeekling.builder Pattern）使用多个简单的对象一步一步构建成一个复杂的对象。这种类型的设计模式属于创建型模式，
它提供了一种创建对象的最佳方式。
## 主要解决
主要解决在软件系统中，有时候面临着"一个复杂对象"的创建工作，其通常由各个部分的子对象用一定的算法构成；由于需求
的变化，这个复杂对象的各个部分经常面临着剧烈的变化，但是将它们组合在一起的算法却相对稳定。
## 建造者的结构
![建造者模式](http://www.zeekling.cn/gogs/zeek/designPattern/raw/master/pics/builder.png)

## 抽象建造者（com.zeekling.builder）角色
给出一个抽象接口，以规范产品对象的各个组成成分的建造。一般而言，此接口独立于应用程序的商业逻辑。模式中直接创建
产品对象的是具体建造者 ConcreteBuilder角色。具体建造者类必须实现这个接口所要求的两种方法：一种是建造方法
buildPart1和 buildPart2，另一种是返还结构方法retrieveResult。一般来说，产品所包含的零件数目与建造方法的数目相符。
换言之，有多少 零件，就有多少相应的建造方法。
## 具体建造者（ConcreteBuilder）角色
担任这个角色的是与应用程序紧密相关的一些类，它们在应用程序调用下创建产品的实例。这个角色要完成的任务包括：
1.实现抽象建造者Builder所声明的接口，给出一步一步地完成创建产品实例的操作。2.在建造过程完成后，提供产品的实例。
## 导演者（Director）角色
担任这个角色的类调用具体建造者角色以创建产品对象。应当指出的是，导演者角色并没有产品类的具体知识，真正拥有产品
类的具体知识的是具体建造者角色。
## 产品（Product）角色
产品便是建造中的复杂对象。一般来说，一个系统中会有多于一个的产品类，而且这些产品类并不一定有共同的接口，而完全
可以是不相关联的。
