# 享元模式
## 简述
享元模式采用一个共享来避免大量拥有相同内容对象的开销。这种开销最常见、最直观的就是内容的消耗。享元对象能够做到共享的关键是区分内蕴态和外蕴态。 <br>
一个内蕴状态是存储在享元对象内部的，并且是不会随着环境的改变而有所不同。因此，一个享元可以具有内蕴状态并可以共享。<br>
一个外蕴状态是随着环境的改变的、不可共享的。享元对象的外蕴状态必须有客户端保存，并在享元对象被创建之后，在需要使用的时候在传入享元对象内部。
外蕴状态不可以影响到享元对象的内蕴状态，他们是相互独立的<br>
享元模式可以分为单纯享元模式和复合享元模式。<br>

## 单纯享元模式
在单纯享元模式中，所有的对象都是可以共享。<br>

![单纯享元模式](https://github.com/lzh984294471/designPattern/raw/master/pics/flyweight1.png)

### 单纯享元模式中所涉及到的角色：

* 抽象享元角色：给出一个抽象接口，以规定所有具体的享元角色需要实现的方法。
* 具体享元角色：实现抽象享元角色所规定出的接口。如果有内蕴状态的话，必须负责为内蕴状态提供存储空间。
* 享元工厂角色：本角色负责创建和管理享元角色。本角色必须保证享元对象可以被系统适当的共享。当一个客户端对象调用一个享元对象的时候，享元工厂角色会
检查系统中是否已经存在有一个符合要求的享元对象。如果已经有了，享元工厂角色就应当提供这个已有的享元对象；如果系统中没有一个合适的享元对象的话，享
元工厂角色就应当创建一个合适的享元角色。

## 复合享元模式

### 简述
在单纯享元模式中，所有的享元对象都是单纯享元对象，也就是都可以直接共享的。还有一种较为复杂的情况，将一些单纯享元使用合成模式加以复用，形成复合享
元对象。这样的复合享元对象本身不能共享，但是他们可以分解成单纯享元对象，而后者则可以共享。<br>

![复合享元模式](https://github.com/lzh984294471/designPattern/raw/master/pics/flyweight2.png) <br>

### 复合享元角色所涉及的角色：

* 抽象享元角色：给出一个抽象接口，以规定出所有具体享元角色需要实现的方法。
* 实现抽象享元角色所规定出的接口。如果有内蕴状态的话，必须负责为内蕴状态提供存储空间。
* 复合享元角色所代表的对象是不可以共享的，但是一个复合享元对象可以分解成为多个本身是单纯享元对象的组合。复合享元角色又称作不可共享的享元对象。
* 本角色负责创建和管理享元角色。本角色必须保证享元对象可以被系统适当地共享。当一个客户端对象调用一个享元对象的时候，享元工厂角色会检查系统中是否
已经有 一个符合要求的享元对象。如果已经有了，享元工厂角色就应当提供这个已有的享元对象；如果系统中没有一个适当的享元对象的话，享元工厂角色就应当创
建一个 合适的享元对象。

