
package com.zeekling.simpleFactory;

/**
 * Created by lzh on 3/28/16.
 */
public class CarFactoryImpl implements CarFactory{
    private Car car;

    /**
     *
     * @param clazz 传入要利用工厂进行实现的类
     * @return 返回构造器实例化后的方法
     */
    public Car getCar(Class<? extends Car> clazz){
        try {
            car = (Car) Class.forName(clazz.getName()).newInstance();
            //newInstance()是弱类型，只能调用无参构造器
        } catch (InstantiationException | IllegalAccessException | ClassNotFoundException e) {
            e.printStackTrace();
        }
        return car;
    }
}
